Rem
Rem	Opening book loader for Saitek-OSA-Interace (COM port)
Rem V1.0
Rem

#include "vbcompat.bi"

'
'   Main program
'

DIM As UShort i, bank, row, col, count, errors
DIM As String indata, dat, fname, libmem, bl, cdata
DIM As String actCOM, actBaud, ki
Dim Shared nParams As UByte
ReDim Shared Param(1 To 2) As String
Dim As String lsd_fil = "Text files (*.TXT)" + Chr(0) + "*.TXT" + Chr(0)_
+ "All files (*.*)" + Chr(0) + "*.*" + Chr(0, 0)
actCOM = "COM1:"
actBaud = "1200"

' Checking for INI file
If FileExists("osa.ini") Then
    Open "osa.ini" for Input As #4
    Do Until EOF(4)
        Line Input #4, indata
        indata = Trim(indata) : dat = ""
        ' Strip off blanks
        For i = 1 to Len(indata)
            If Mid(indata, i, 1) <> " " Then dat = dat + Mid(indata, i, 1)
        Next i
        If LCase(Left(dat, 4)) = "com=" Then actCOM = Mid(dat, 5)
        If LCase(Left(dat, 5)) = "baud=" Then actBaud = Mid(dat, 6)
    Loop
    Close #4                        
End If

'' Checking for command line parameters
nParams = 0
While Command(nParams + 1) <> ""
    nParams = nParams + 1
Wend
If nParams > 0 Then
    ReDim Param(1 To nParams) As String
    For i = 1 To nParams
        Param(i) = Command(i)
    Next i
End If

WindowTitle "OSA book loader V1.0"
Screen 20,32,1,&H04   ' 1024x768, 128x48, 32 bit palette, no full-screen
Color RGB(0,0,0), RGB(255,255,255)
Cls

#Include once "LoadSaveDialog.inc"

' Help
If UCase(Param(1)) = "/?" Or UCase(Param(1)) = "/H" Then
    Print
    Print "Book loader for Scisys/Saitek chess boards"
    Print "(C) 2009 by Achim Pietig, Version 1.0"
    Print
    Print "Usage: OSA-Book [/?] Or [/h]"
    Print "       OSA-Book filename [COMx:] [baud]"
    Print "Call without parameters 2 and/or 3 sets COM1: with 1200 baud"
    Print "Board shall be set to corresponding baud rate before!"
    Print
    Print "e.g.   OSA-Book book.txt                (COM1: with 1200 baud)"
    Print "       OSA-Book book.txt COM2:          (COM2: with 1200 baud)"
    Print "       OSA-Book book.txt COM3: 9600     (COM3: with 9600 baud)"
    Sleep
    End
End If

' Init program parameters
If nParams = 0 Then
    fname = LoadSaveDialog (,lsd_fil)
Else
    fname = Param(1)
    If nParams > 1 Then actCOM = UCase(Param(2))
    If nParams > 2 Then actBaud = Param(3)
End If

Open fname For Input As #1
If Err <> 0 Then Print "File not found" : Sleep : End

If Open Com (actCOM + actbaud + ",N,8,1,CS0,DS0,CD0,RS,BIN" For Binary As #2) <> 0 Then
    Print "Cannot initialise comport"
    Close
    Sleep
    End
End If

Print #2, "ENGLISH"
Sleep 250,1

Print #2, "OPEN"
Do
    dat = Input(1, #2)
    If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
Loop Until dat = Chr(&H17)
Cls
Print "   "; Trim(cdata)
Print

Print #2, "SENDINFO OFF"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

Print #2, "BOARD OFF"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

row = 1 : col = 1 : bank = 1 : count = 0

' Program loop
Do
    ' Check for ESC or window close
    ki = inkey
    If ki = Chr$(27) Or ki = Chr(255)+"k" Then
        Print #2, "CLOSE"
        Close
        End
    End If
    ' Read next line from book file, skip comments/undefined lines and strip off blanks
    Do
        Line Input #1, indata
        indata = LCase(Trim(indata))
    Loop Until Left(indata, 1) >= "a" And Left(indata, 1) <= "h"
    bl = ""
    For i = 1 To Len(indata)
        If Mid(indata, i, 1) <> " " Then bl = bl + Mid(indata, i, 1)
    Next i
    ' Exit if last input is 'delete'
    If Left(bl, 3) = "del" Then Exit Do
    ' Reset board
    Print #2, "NEWGAME"
    Do
        dat = Input(1, #2)
    Loop Until dat = Chr(&H17)
    Print #2, "ANALYSIS"
    Do
        dat = Input(1, #2)
    Loop Until dat = Chr(&H17)
    ' Fetch move from book line and send to board
    For i = 1 To Len(bl) Step 4
        indata = Mid(bl, i, 4)
        indata = Left(indata, 2) + "-" + Right(indata, 2)
        Print #2, "MOVE "; indata
        Do
            dat = Input(1, #2)
        Loop Until dat = Chr(&H17)
        Sleep 750, 1
        ' Flush COM buffer
        While LOC(2) > 0
            dat = Input(LOC(2), #2)
        Wend
    Next i
    ' Calculate next lib-memory, delete content and store new moves
    libmem = Chr(48 + bank) + "," + Chr(96 + col) + Chr(48 + row)
    Print #2, "LIBRARY"
    Do
        dat = Input(1, #2)
    Loop Until dat = Chr(&H17)
    Print #2, "INDEX "; libmem
        Do
            dat = Input(1, #2)
        Loop Until dat = Chr(&H17)
    Print #2, "FUNCTION -"
        Do
            dat = Input(1, #2)
        Loop Until dat = Chr(&H17)
    Print #2, "FUNCTION TAB"
    cdata = ""
    Do
        dat = Input(1, #2)
        If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
    Loop Until dat = Chr(&H17)
    row = row + 1 : count = count + 1
    If row > 8 Then row = 1 : col = col + 1
    If col > 8 Then col = 1 : bank = bank + 1
    Print "   "; Left(bl, 80);
    Locate ,95 : Print "Bank "; libmem;
    Locate ,115
    If Instr(cdata, "???") = 0 Then
        Print " OK"
    Else
        Print " Error"
        errors = errors + 1
    End If

Loop Until EOF(1) Or (bank = 6 And row = 8 And col = 8)

While count < 383 And Left(bl, 3) = "del"
    ' Check for ESC or window close
    ki = inkey
    If ki = Chr$(27) Or ki = Chr(255)+"k" Then
        Print #2, "CLOSE"
        Close
        End
    End If
    ' Calculate next lib-memory and delete content
    libmem = Chr(48 + bank) + "," + Chr(96 + col) + Chr(48 + row)
    Print #2, "INDEX "; libmem
    Do
        dat = Input(1, #2)
    Loop Until dat = Chr(&H17)
    Print #2, "FUNCTION -"
    cdata = ""
    Do
        dat = Input(1, #2)
        If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
    Loop Until dat = Chr(&H17)
    Print "   Delete Bank "; libmem;
    Locate ,25
    If Instr(cdata, "???") = 0 Then
        Print " OK"
    Else
        Print " Error"
        errors = errors + 1
    End If
    row = row + 1 : count = count + 1
    If row > 8 Then row = 1 : col = col + 1
    If col > 8 Then col = 1 : bank = bank + 1
Wend

Print #2, "NEWGAME"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)
Print #2, "BOARD ON"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)
Sleep 750, 1

' Close open files and release COM port
Print #2, "CLOSE"
Close
Print
Print "   DONE ("; errors; " errors)"
Sleep
End
