Rem
Rem	Loading of a OSA-PGN file with Saitek-OSA-Interace (COM port)
Rem V0.1
Rem

#include "vbcompat.bi"

'
'   Main program
'

DIM As UShort i, osa
DIM As String indata, dat, fname, cdata, bl, wm, bm, wu, bu
DIM As String actCOM, actBaud, ki
Dim Shared nParams As UByte
ReDim Shared Param(1 To 2) As String
Dim As String lsd_fil = "PGN files (*.PGN)" + Chr(0) + "*.PGN" + Chr(0)_
+ "All files (*.*)" + Chr(0) + "*.*" + Chr(0, 0)
actCOM = "COM1:"
actBaud = "1200"

' Checking for INI file
If FileExists("osa.ini") Then
    Open "osa.ini" for Input As #4
    Do Until EOF(4)
        Line Input #4, indata
        indata = Trim(indata) : dat = ""
        ' Strip off blanks
        For i = 1 to Len(indata)
            If Mid(indata, i, 1) <> " " Then dat = dat + Mid(indata, i, 1)
        Next i
        If LCase(Left(dat, 4)) = "com=" Then actCOM = Mid(dat, 5)
        If LCase(Left(dat, 5)) = "baud=" Then actBaud = Mid(dat, 6)
    Loop
    Close #4                        
End If

'' Checking for command line parameters
nParams = 0
While Command(nParams + 1) <> ""
    nParams = nParams + 1
Wend
If nParams > 0 Then
    ReDim Param(1 To nParams) As String
    For i = 1 To nParams
        Param(i) = Command(i)
    Next i
End If

WindowTitle "OSA-Load V0.1"
Screen 20,32,1,&H04   ' 1024x768, 128x48, 32 bit palette, no full-screen
Color RGB(0,0,0), RGB(255,255,255)
Cls

#Include once "LoadSaveDialog.inc"

' Help
If UCase(Param(1)) = "/?" Or UCase(Param(1)) = "/H" Then
    Print
    Print "Game loader for Scisys/Saitek chess boards"
    Print "(C) 2009 by Achim Pietig, Version 0.1"
    Print
    Print "Usage: OSA-Load [/?] Or [/h]"
    Print "       OSA-Load filename [COMx:] [baud]"
    Print "Call without parameters 2 and/or 3 sets COM1: with 1200 baud"
    Print "Board shall be set to corresponding baud rate before!"
    Print
    Print "e.g.   OSA-Load game.pgn                (COM1: with 1200 baud)"
    Print "       OSA-Load game.pgn COM2:          (COM2: with 1200 baud)"
    Print "       OSA-Load game.pgn COM3: 9600     (COM3: with 9600 baud)"
    Sleep
    End
End If

' Init program parameters
If nParams = 0 Then
    fname = LoadSaveDialog (,lsd_fil)
Else
    fname = Param(1)
    If nParams > 1 Then actCOM = UCase(Param(2))
    If nParams > 2 Then actBaud = Param(3)
End If

Open fname For Input As #1
If Err <> 0 Then Print "File not found" : Sleep : End

If Open Com (actCOM + actbaud + ",N,8,1,CS0,DS0,CD0,RS,BIN" For Binary As #2) <> 0 Then
    Print "Cannot initialise comport"
    Close
    Sleep
    End
End If

Print #2, "ENGLISH"
Sleep 250,1

Print #2, "OPEN"
Do
    dat = Input(1, #2)
    If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
Loop Until dat = Chr(&H17)
Cls
Print Trim(cdata)
Print

Print #2, "SENDINFO OFF"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

Print #2, "BOARD OFF"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

' Reset board
Print #2, "NEWGAME"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)
Print #2, "ANALYSIS"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)

Do
    ' Read next line from PGN file, skip comments/undefined lines
    Line Input #1, indata
    indata = Trim(indata)
    If osa = 1 And InStr(indata, ".") > 0 Then
        ' Delete unnecessary characters, change castling etc.
        indata = Mid(indata, InStr(indata, ".") + 2)
        If InStr(indata, " ") = 0 Then indata = indata + " "
        i = InStr(indata, " ")
        wm = Left(indata, i - 1)
        bm = Trim(Mid(indata, i))
        wu = "" : bu = ""
        If Right(wm, 2) = "ep" Then wm = Left(wm, Len(wm) - 2)
        If Right(bm, 2) = "ep" Then bm = Left(bm, Len(bm) - 2)
        If InStr(wm, "x") > 0 Then Mid(wm, InStr(wm, "x"), 1) = "-"
        If InStr(bm, "x") > 0 Then Mid(bm, InStr(bm, "x"), 1) = "-"
        While Right(wm, 1) = "+"
            wm = Left(wm, Len(wm) - 1)
        Wend
        While Right(bm, 1) = "+"
            bm = Left(bm, Len(bm) - 1)
        Wend
        If InStr(wm, "O-O-O") > 0 Then wm = "e1-c1"
        If InStr(bm, "O-O-O") > 0 Then bm = "e8-c8"
        If InStr(wm, "O-O") > 0 Then wm = "e1-g1"
        If InStr(bm, "O-O") > 0 Then bm = "e8-g8"
        If InStr(wm, "/") > 0 Then wu = Right(wm, 2)
        If InStr(bm, "/") > 0 Then bu = Right(bm, 2)
        wm = Mid(wm, InStr(wm, "-") - 2, 5) + wu 
        bm = Mid(bm, InStr(bm, "-") - 2, 5) + bu
        
        ' Send moves to board
        Print #2, "MOVE "; wm
        cdata = ""
        Do
            dat = Input(1, #2)
            If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
        Loop Until dat = Chr(&H17)
        Print cdata,
        Sleep 750, 1
        ' Flush COM buffer
        While LOC(2) > 0
            dat = Input(LOC(2), #2)
        Wend
        If Len(bm) > 4 Then
            Print #2, "MOVE "; bm
            cdata = ""
            Do
                dat = Input(1, #2)
                If Asc(dat) > 31 And dat <> ">" Then cdata = cdata + dat
            Loop Until dat = Chr(&H17)
            Print cdata
            Sleep 750, 1
            ' Flush COM buffer
            While LOC(2) > 0
                dat = Input(LOC(2), #2)
            Wend
        End If
    End If
    If Left(indata, 4) = "%OSA" Then osa = 1
    ' Check for ESC or window close
    ki = inkey
    If ki = Chr$(27) Or ki = Chr(255)+"k" Then
        Print #2, "CLOSE"
        Close
        End
    End If

Loop Until EOF(1)

Print #2, "NORMAL"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)
Print #2, "BOARD ON"
Do
    dat = Input(1, #2)
Loop Until dat = Chr(&H17)
Sleep 750, 1

' Close open files and release COM port
Print #2, "CLOSE"
Close
Print

If osa = 0 Then
    Print "No compatible PGN file found"
Else
    Print "DONE"
End If
Sleep
End
